{% extends "base_device.yaml.jinja2" %}

{% set invalid_sig_capsule_url = "https://gitlab.com/Linaro/blueprints/ci-artifacts/-/raw/rockpi4b-invalid-capsule-0.0/rockpi4b_invalid_sig.capsule" %}

{% block device_setup %}
device_type: rk3399-rock-pi-4b
job_name: {{ lava_job_name }}
visibility: public
timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2

context:
  lava_test_results_dir: /var/lib/lava-%s

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      firmware:
        url: {{ firmware_url }}
        {%- set firmware_path, firmware_extension = splitext(firmware_url) %}
        compression: {{ firmware_extension[1:] }}
      os:
        url: {{ os_url }}
        {%- set os_path, os_extension = splitext(os_url) %}
        compression: {{ os_extension[1:] }}
      script:
        url: https://gitlab.com/Linaro/blueprints/ci/-/raw/HEAD/support_files/ts-merge-images.sh
      capsule:
        url: {{ capsule_url }}
      invalid_sig:
        url: {{ invalid_sig_capsule_url }}
      {%- if testexport_url %}
      testexport:
        url: {{ testexport_url }}
      {%- endif %}
    postprocess:
      docker:
        image: debian
        timeout:
          minutes: 60
        steps:
          {%- set firmware_basename = basename(firmware_path) %}
          {%- set os_basename = basename(os_path) %}
          - 'apt-get update'
          - 'apt-get install -qy fdisk gdisk'
          - 'fdisk -l {{ firmware_basename }}'
          - 'fdisk -l {{ os_basename }}'
          - 'bash ts-merge-images.sh {{ firmware_basename }} {{ os_basename }}'
          - 'fdisk -l {{ firmware_basename }}'
          - dd if=/dev/urandom of=random_data.capsule bs=1K count=1K

- deploy:
    to: flasher
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      image:
        url: downloads://{{ firmware_basename }}
        partition: 6
        format: ext4
        overlays:
          lava: true

- boot:
    method: u-boot
    timeout:
      minutes: 15
    commands:
      # Clean up all all previous boot options and capsules
      - "for i in '0000 0001 0002 0003 0004 0005 0006 0007 0008 0009 000A 000B 000C 000D 000E 000F 0010 0011 0012 0013 0014 0015 0016 0017 0018 0019 001A 001B 001C 001D 1001 4095'; do efidebug boot rm $i; done"
      - "for i in '0000 0001 0002 0003 0004 0005 0006 0007 0008 0009 000A 000B 000C 000D 000E 000F 0010 0011 0012 0013 0014 0015 0016 0017 0018 0019 001A 001B 001C 001D 001E 001F 0020 0021 0022 0023 0024 0025 0026 0027 0028 0029 002A 002B 002C 002D 002E 002F 0030 0031 0032 0033 0034 0035 0036 0037 0038 0039 003A 003B 003C 003D 003E 003F 0040 0041 0042 0043 0044 0045 0046 0047 0047 0048 0049 004A 004B 004C 004D 004E 004F 0050 0051 0052 0053 0054 0055 0056 0057 0058 0059 005A 005B 005C 005D 005E 005F 0060 0061 0062 0063 0064 0065 0066 0067 0068 0069 006A 006B 006C 006D 006E 006F 0070 0071 0072 0073 0074 0075 0076 0077 0078 0079 007A 007B 007C 007D 007E 007F 0080 0081 0082 0083 0084 0085 0086 0087 0088 0089 008A 008B 008C 008D 008E 008F'; do setenv -e -nv -rt -bs -guid 39b68c46-f7fb-441b-b6ec-16b0f69821f3 Capsule$i; done"
      - "printenv -e"
      # It's required to pass the serial port to access the login prompt
      - "efidebug boot add -b 1 Boot0000 mmc 1:6 efi/boot/bootaa64.efi -i mmc 1:6 ledge-initramfs-trs-qemuarm64.rootfs.cpio.gz -s 'console=ttyS2,1500000 root=UUID=6091b3a4-ce08-3020-93a6-f755a22ef03b rootwait panic=60'"
      - "efidebug boot order 1"
      - 'echo "Starting kernel"; bootefi bootmgr'
    auto_login:
      login_prompt: 'login:'
      username: 'root'
      login_commands:
        - sudo su -
    prompts:
      - ewaol@(.*):[/~]\$
      - root@(.*):[/~]#
    transfer_overlay:
      download_command: wget -t 20 --waitretry 20 --retry-connrefused --retry-on-host-error --retry-on-http-error=401,403
      unpack_command: tar -C /var/lib/ -xzvf
{% endblock %}
